import { sign, verify } from "jsonwebtoken"
import { cookies } from "next/headers"

// In a real application, use environment variables for these values
const JWT_SECRET = "your-secret-key-change-this-in-production"
const ADMIN_USERNAME = "admin"
const ADMIN_PASSWORD = "password123" // Change this to a secure password

export interface AdminUser {
  username: string
  role: "admin"
}

export async function loginAdmin(username: string, password: string) {
  // Simple authentication check
  if (username === ADMIN_USERNAME && password === ADMIN_PASSWORD) {
    const user: AdminUser = { username, role: "admin" }
    const token = sign(user, JWT_SECRET, { expiresIn: "1d" })
    return { success: true, token }
  }
  return { success: false, error: "Invalid credentials" }
}

export async function verifyAuth(token: string) {
  try {
    const user = verify(token, JWT_SECRET) as AdminUser
    return { success: true, user }
  } catch (error) {
    return { success: false, error: "Invalid token" }
  }
}

export function getAuthToken() {
  const cookieStore = cookies()
  return cookieStore.get("auth-token")?.value
}

export function isAdmin(user: any): user is AdminUser {
  return user && user.role === "admin"
}

